//获取指定form中的所有的<input>对象    
function getElements(formId) {    
    var elements = new Array();    
    if(!formId)
    	return elements;
    var form = mui("#"+formId)[0]; 
    if(!form)
    	return elements;
    var tagElements = form.getElementsByTagName('input');    
    for (var j = 0; j < tagElements.length; j++){  
         elements.push(tagElements[j]);  
  
    }  
    return elements;    
}   
  
//获取单个input中的【name,value】数组  
function inputSelector(element) {    
  if (element.checked)    
     return [element.name, element.value];    
}    
      
function input(element) {    
    switch (element.type.toLowerCase()) {    
      case 'submit':    
      case 'hidden':    
      case 'password':    
      case 'text':    
      case 'range':    
      case 'number':
      case 'search':
       return [element.name, element.value];    
      case 'checkbox':    
      case 'radio':    
        return inputSelector(element);    
    }    
    return false;    
}    
  
//组合URL  
function serializeElement(element) {    
    //var method = element.tagName.toLowerCase();    
    var parameter = input(element);    
    
    if (parameter) {    
      var key = encodeURIComponent(parameter[0]);    
      if (key.length == 0) return;    
    
      if (parameter[1].constructor != Array)    
        parameter[1] = [parameter[1]];    
          
      var values = parameter[1];    
      var results = [];    
      for (var i=0; i<values.length; i++) {    
        results.push(key + '=' + encodeURIComponent(values[i]));    
      }    
      return results.join('&');    
    }    
 }    
  
//调用方法     
function serializeForm(formId)
{
    var elements = getElements(formId);    
    var queryComponents = new Array();    
    
    for (var i = 0; i < elements.length; i++) {    
      var queryComponent = serializeElement(elements[i]);    
      if (queryComponent)    
        queryComponents.push(queryComponent);    
    }
    
    var form = mui("#"+formId)[0]; 
    if(form)
    {
	    elements = form.getElementsByTagName('select');
	    for (var i = 0; i < elements.length; i++)
	    {
	    	if(!elements[i].name)
	    		continue;
	    	var queryComponent = elements[i].name + "=" + encodeURIComponent(elements[i].value);
	    	if (queryComponent)
	    		queryComponents.push(queryComponent);
	    }
	    elements = form.getElementsByTagName('textarea');
	    for (var i = 0; i < elements.length; i++)
	    {
	    	if(!elements[i].name)
	    		continue;
	    	//alert(elements[i].value);
	    	var queryComponent = elements[i].name + "=" + encodeURIComponent(elements[i].value);
	    	//alert(queryComponent);
	    	if (queryComponent)
	    		queryComponents.push(queryComponent);
	    }
    }
    
    return queryComponents.join('&');  
}    
function serialize(formId, data)
{
	data = data || "";
	var s = serializeForm(formId);
	if(typeof data == "object")
	{
		var d = [];
		for(var name in data)
			d.push(name + "=" + data[name]);
		s += "&" + d.join("&");
	}
	else if(data && typeof data == "string")
	{
		if(s)
			s += "&" + data;
		else
			s = data;
	}
	return s;
};

function Template()
{
	this.html = "";
	this.render = null;
}

Template.prototype.CompileById = function(elementId)
	{
		var obj = mui("#"+elementId)[0];
		if(!obj)
			return;
		this.html = obj.innerHTML;
		this.CompileBySource(this.html);
	};
	
	Template.prototype.CompileByUrl = function(url)
	{
		ajax(url, {dataType: "text", userdata: this, callback: this.CompileBySource});
	};
	
	Template.prototype.CompileBySource = function(Source, userdata)
	{
		var ts = userdata || this;
		ts.html = Source;
		ts.render = template.compile(ts.html);
	};
	
	Template.prototype.Render = function(data, destId)
	{
		if(!this.render)
			return;
		var htmlData = this.render(data);
		//console.log(htmlData);
		mui("#"+destId)[0].innerHTML = htmlData;
	};
	Template.prototype.getSource = function()
	{
		return this.html;
	};


var pageTemplate = new Template();
pageTemplate.CompileByUrl("../../data/tpl/page.tpl");

var Page =
{
	OptionData: {},
	PageID: 1,
	//formId:"", templatePageId: "", templatePageUrl: "", templatePageSource: ""
	//templateId: "", templateUrl: "", templateSource: "", PageSize:20, CountPerPageList: 5
	//pageId: "", contentId:"", data:"", url:""
	init: function(options)
	{
		options = options || {};
		//Page.OptionData[Page.PageID] = options;
		Page.OptionData = options;
		options.id = Page.PageID;
		Page.PageID++;
		options.PageSize = options.PageSize || 20;
		options.CountPerPageList = options.CountPerPageList || 3;
		//分页模板
		options.templatePage = options.templatePage || pageTemplate;//options.templatePage || new Template();
		/*if(options.templatePageSource)
			options.templatePage.CompileBySource(options.templatePageSource);
		else if(options.templatePageId)
			options.templatePage.CompileById(options.templatePageId);
		else if(options.templatePageUrl)
			options.templatePage.CompileByUrl(options.templatePageUrl);*/
		
		//内容页模板
		options.template = options.template || new Template();
		if(options.templateSource)
			options.template.CompileBySource(options.templateSource);
		else if(options.templateId)
			options.template.CompileById(options.templateId);
		else if(options.templateUrl)
			options.template.CompileByUrl(options.templateUrl);
		return options.id;
	},
	getOptions: function(PageID)
	{
		var opt = Page.OptionData;//[PageID];
		return opt;
	},
	search: function(PageID, url, formId, data)
	{
		var opt = Page.getOptions(PageID);
		opt.PageIndex = 1;
		opt.PageCount = 0;
		opt.RowCount = 0;
		opt.formId = formId || opt.formId;
		opt.data = data || opt.data;
		opt.url = url || opt.url;
		Page.toPage(opt);
	},
	toPage: function(opt)
	{
		var data = serialize(opt.formId, opt.data);
		
		opt.PageIndex = opt.PageIndex || 1;
		var url = opt.url;
		var index = url.indexOf("?");
		if(index < 0)
			url += "?";
		url += opt.PageIndex + "-" + opt.PageSize;
		//console.log("Page Start:::" + new Date());
		ajax(url, {data: data, userdata: opt, callback: Page.toPageComplete});
	},
	toPageComplete: function (PageData, opt)
	{
		//console.log("Page End:::" + new Date());
		opt.RowCount = PageData.total;
		opt.PageCount = parseInt(PageData.total / opt.PageSize);
		if(opt.PageCount * opt.PageSize < PageData.total)
			opt.PageCount++;
		if(opt.PageIndex > opt.PageCount)
			opt.PageIndex = opt.PageCount;
		var i = parseInt((opt.PageIndex - 1) / opt.CountPerPageList);
		var data = {
			PageID: opt.id,
			PageIndex: opt.PageIndex,
			PageCount: opt.PageCount,
			ListFirst: opt.CountPerPageList * i + 1,
			ListLast: opt.CountPerPageList * i + 1 + 5,
			PageList: []
		};
		for(var j = 0; j < opt.CountPerPageList; j++)
		{
			data.PageList.push(j + data.ListFirst);
			if(j + data.ListFirst >= opt.PageCount)
				break;
		}
		
		//alert(PageData.total);
		if(opt.contentId)
			opt.template.Render(PageData, opt.contentId);
		if(opt.pageId)
			opt.templatePage.Render(data, opt.pageId);
			
		
		if(opt.callback)
			opt.callback(opt.PageIndex, PageData);
	},
	OnPage: function(PageID, PageIndex)
	{
		var opt = Page.getOptions(PageID);
		opt.PageIndex = PageIndex;
		Page.toPage(opt);
	},
	Refresh: function(PageID)
	{
		var opt = Page.getOptions(PageID);
		//opt.PageIndex = PageIndex;
		Page.toPage(opt);
	},
	OnPrevPageList: function(PageID, FisrPage)
	{
		var opt = Page.getOptions(PageID);
		if(opt)
		{
			opt.PageIndex = FisrPage - opt.CountPerPageList;
			Page.toPage(opt);
		}
	},
	OnNextPageList: function (PageID, FisrPage)
	{
		var opt = Page.getOptions(PageID);
		if(opt)
		{
			opt.PageIndex = FisrPage;// - CountPerPageList;
			Page.toPage(opt);
		}
	}
};